#detect player's height
execute as @a store result score @s y run data get entity @s Pos[1]

#game
execute if entity @e[type=area_effect_cloud,name=game,limit=1,tag=ingame] run function sette:game_loop
execute unless entity @e[type=minecraft:area_effect_cloud,tag=generate,limit=1] run scoreboard players set arena_gen game_stats 0

#effects
effect give @a saturation 1 10 true
effect give @a resistance 1000000 100 true
execute unless entity @e[tag=ingame] run effect give @a weakness 5 100 true

#people running around the lobby


#start
execute if entity @e[type=minecraft:area_effect_cloud,tag=start] run scoreboard players add start game_stats 1
execute if score start game_stats matches 60.. run schedule function sette:started 1t
execute if score start game_stats matches 60.. run tag @e[tag=start,type=minecraft:area_effect_cloud] remove start

#join
execute unless entity @e[type=minecraft:area_effect_cloud,tag=ingame,limit=1] run gamemode adventure @a[tag=!joined]
execute if entity @e[type=minecraft:area_effect_cloud,tag=ingame,limit=1] run gamemode spectator @a[tag=!joined]
team join spectator @a[tag=!joined]
execute as @a[tag=!joined] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 10 0.9
execute as @a[tag=!joined] run title @s title ["",{"text":"Pillar Ninjas","color":"gold"}]
execute as @a[tag=!joined] run title @s subtitle ["",{"text":"by Supersette","color":"red"}]
teleport @a[tag=!joined] 0 59 0 270 0
execute if entity @a[tag=!joined] run effect give @a[tag=!joined] blindness 1 1 true
title @a[tag=!joined] times 0 50 5
clear @a[tag=!joined]
tag @a[tag=!joined] remove hasBall
execute if entity @a[tag=!joined] run tag @a[tag=!joined] add joined
#jointeam
execute if entity @a[tag=welcomed_b,team=red] run tag @a[tag=welcomed_b,team=red] remove welcomed_b
execute if entity @a[tag=welcomed_r,team=red] run tag @a[tag=welcomed_r,team=red] remove welcomed_s
execute if entity @a[tag=welcomed_r,team=blue] run tag @a[tag=welcomed_r,team=blue] remove welcomed_r
execute if entity @a[tag=welcomed_b,team=blue] run tag @a[tag=welcomed_b,team=blue] remove welcomed_s
execute as @a[tag=welcomed_b,team=spectator] run tag @s remove welcomed_b
execute as @a[tag=welcomed_r,team=spectator] run tag @s remove welcomed_r
execute as @a[tag=welcomed_b]

execute as @a[team=blue,tag=!welcomed_b] run title @s actionbar ["",{"text":"You joined blue!","bold":true,"color":"blue"}]
execute as @a[team=red,tag=!welcomed_r] run title @s actionbar ["",{"text":"You joined red!","bold":true,"color":"red"}]
execute as @a[team=spectator,tag=!welcomed_s] run title @s actionbar ["",{"text":"You're now spectating!","bold":true,"color":"gray"}]
execute as @a[team=blue,tag=!welcomed_b] run playsound minecraft:block.note_block.bell master @s ~ ~ ~ 10 1.5
execute as @a[team=red,tag=!welcomed_r] run playsound minecraft:block.note_block.bell master @s ~ ~ ~ 10 1.5
execute if entity @a[tag=!welcomed_b,team=blue] run tag @a[tag=!welcomed_b,team=blue] add welcomed_b
execute if entity @a[tag=!welcomed_r,team=red] run tag @a[tag=!welcomed_r,team=red] add welcomed_r
execute if entity @a[tag=!welcomed_s,team=spectator] run tag @a[tag=!welcomed_s,team=spectator] add welcomed_s


#concrete to join teams
execute unless score start_title game_stats matches ..70 unless entity @e[tag=ingame] as @a at @s if block ~ ~-1 ~ red_concrete run team join red @s
execute unless score start_title game_stats matches ..70 unless entity @e[tag=ingame] as @a at @s if block ~ ~-1 ~ blue_concrete run team join blue @s

#terrain
execute as @e[type=minecraft:area_effect_cloud,tag=terrain,limit=1] at @s unless block ~ ~ ~ grass_block run fill ~ ~ ~ ~-42 ~ ~42 grass_block replace air
execute as @e[type=minecraft:area_effect_cloud,tag=terrain,limit=1] at @s unless block ~ ~1 ~ air run fill ~ ~1 ~ ~-42 ~1 ~42 air replace grass_block
execute as @e[type=minecraft:area_effect_cloud,tag=terrain,limit=1] at @s unless block ~ ~-1 ~ air run fill ~ ~-1 ~ ~-42 ~-1 ~42 air replace grass_block

execute if score Supersette terrain matches 1 run function sette:floating_terrain/go_up
execute if score Supersette terrain matches -1 run function sette:floating_terrain/go_down

#leave
execute as @a[scores={leave=1..}] at @s run tag @s remove joined
execute as @a[scores={leave=1..}] at @s run scoreboard players reset @s leave

#arena clearer
execute if score arena_clearer game_stats matches 1..10 run function sette:arena/arena_clearer

#start title
execute if score start_title game_stats matches ..60 run function sette:start_title

#firework powerup
execute as @e[type=firework_rocket] at @s run summon area_effect_cloud ~ ~0.1 ~ {Duration:20,Tags:["firework"]}
execute as @e[type=firework_rocket] at @s run playsound minecraft:entity.firework_rocket.launch master @a ~ ~ ~ 10 1.2
execute as @e[type=minecraft:area_effect_cloud,tag=firework] at @s run particle firework ~ ~ ~ 0.25 0.15 0.25 0.01 5 force
execute as @e[type=minecraft:firework_rocket] run kill @s
execute as @e[type=minecraft:area_effect_cloud,tag=firework] at @s run scoreboard players set @a[distance=..1] levitation 4
#effects
effect give @a[scores={levitation=1..}] levitation 1 20 true
effect clear @a[scores={levitation=1}] levitation
scoreboard players remove @a[scores={levitation=1..}] levitation 1

#trap powerup
execute as @a[team=red] at @s positioned ~ ~1 ~ run tag @e[type=item,nbt={Item:{id:"minecraft:tnt"}},distance=..1] add red
execute as @e[type=item,tag=red,nbt={OnGround:1b}] at @s run summon minecraft:area_effect_cloud ~ ~ ~ {Duration:2500,Tags:["red","trap"]}
execute as @e[type=item,tag=red,nbt={OnGround:1b}] at @s run playsound minecraft:entity.creeper.primed master @a ~ ~ ~ 10 1
execute as @e[type=item,tag=red,nbt={OnGround:1b}] at @s run particle lava ~ ~ ~ 0.1 0.1 0.1 0 5
execute as @e[type=item,tag=red,nbt={OnGround:1b}] at @s run kill @s
execute as @e[type=minecraft:area_effect_cloud,tag=trap,tag=red] at @s run particle dripping_lava ~ ~-0.6 ~ 0.15 0.4 0.15 0 1
execute as @e[type=minecraft:area_effect_cloud,tag=trap,tag=red] at @s if entity @a[team=blue,distance=..1] run summon minecraft:creeper ~ ~1 ~ {Silent:1b,ExplosionRadius:5b,Fuse:0,ignited:1b}
execute as @e[type=minecraft:area_effect_cloud,tag=trap,tag=red] at @s if entity @a[team=blue,distance=..1] run title @a[distance=..5] actionbar ["",{"text":"Trap triggered!","color":"red"}]
execute as @e[type=minecraft:area_effect_cloud,tag=trap,tag=red] at @s if entity @a[team=blue,distance=..1] run kill @s

execute as @a[team=blue] at @s positioned ~ ~1 ~ run tag @e[type=item,nbt={Item:{id:"minecraft:tnt"}},distance=..1] add blue
execute as @e[type=item,tag=blue,nbt={OnGround:1b}] at @s run summon minecraft:area_effect_cloud ~ ~ ~ {Duration:2500,Tags:["blue","trap"]}
execute as @e[type=item,tag=blue,nbt={OnGround:1b}] at @s run playsound minecraft:entity.creeper.primed master @a ~ ~ ~ 10 1
execute as @e[type=item,tag=blue,nbt={OnGround:1b}] at @s run particle lava ~ ~ ~ 0.1 0.1 0.1 0 5
execute as @e[type=item,tag=blue,nbt={OnGround:1b}] at @s run kill @s
execute as @e[type=minecraft:area_effect_cloud,tag=trap,tag=blue] at @s run particle dripping_lava ~ ~-0.6 ~ 0.15 0.4 0.15 0 1
execute as @e[type=minecraft:area_effect_cloud,tag=trap,tag=blue] at @s if entity @a[team=red,distance=..1] run summon minecraft:creeper ~ ~1 ~ {Silent:1b,ExplosionRadius:5b,Fuse:0,ignited:1b}
execute as @e[type=minecraft:area_effect_cloud,tag=trap,tag=blue] at @s if entity @a[team=red,distance=..1] run title @a[distance=..5] actionbar ["",{"text":"Trap triggered!","color":"red"}]
execute as @e[type=minecraft:area_effect_cloud,tag=trap,tag=blue] at @s if entity @a[team=red,distance=..1] run kill @s

#snowball powerup
execute as @a[team=blue] at @s positioned ~ ~1 ~ run tag @e[type=snowball,limit=1,distance=..2,sort=nearest,tag=!redBall] add blueBall
execute as @e[type=snowball,tag=blueBall] at @s run effect give @a[distance=..5,team=red] blindness 5 1 true
execute as @e[type=snowball,tag=blueBall] at @s run particle dust 0 0 1 1 ~ ~ ~ 0.2 0.2 0.2 0.01 2

execute as @a[team=red] at @s positioned ~ ~1 ~ run tag @e[type=snowball,limit=1,distance=..2,sort=nearest,tag=!blueBall] add redBall
execute as @e[type=snowball,tag=redBall] at @s run effect give @a[distance=..5,team=blue] blindness 5 1 true
execute as @e[type=snowball,tag=redBall] at @s run particle dust 1 0 0 1 ~ ~ ~ 0.2 0.2 0.2 0.01 2

#lightning powerup
execute as @a[team=!spectator] at @s positioned ~ ~1 ~ run tag @e[type=item,nbt={Item:{id:"minecraft:totem_of_undying"}},distance=..1] add lightning
execute as @e[type=item,tag=lightning] if entity @a[tag=hasBall] at @a[tag=hasBall] run summon lightning_bolt ~ ~ ~
execute as @e[type=item,tag=lightning] if entity @a[tag=hasBall] at @a[tag=hasBall] run title @a actionbar ["",{"text":"A lightning was summoned!","color":"yellow"}]
execute as @e[type=item,tag=lightning] unless entity @a[tag=hasBall] at @e[type=item,tag=lightning] run title @a[distance=..2] actionbar ["",{"text":"Lightning failed","color":"red"}]
execute as @e[type=item,tag=lightning] unless entity @a[tag=hasBall] at @e[type=item,tag=lightning] run playsound entity.villager.no master @a[distance=..2] ~ ~ ~ 10 1
execute as @e[type=item,tag=lightning] run kill @s

#invertor
execute as @a[team=red] at @s positioned ~ ~1 ~ run tag @e[type=item,nbt={Item:{id:"minecraft:prismarine_shard"}},distance=..1] add red_inverter
execute if entity @e[type=item,tag=red_inverter] as @a[team=blue] at @s run teleport @s ~ ~ ~ ~180 ~
execute as @e[type=item,tag=red_inverter] at @s run playsound minecraft:entity.enderman.teleport master @a[team=red] ~ ~ ~ 100 0
execute as @e[type=item,tag=red_inverter] at @s run playsound minecraft:entity.enderman.teleport master @a[team=blue] ~ ~ ~ 100 2
execute if entity @e[type=item,tag=red_inverter] as @a[team=blue] at @s run particle portal ~ ~ ~ 0.25 0.25 0.25 5 100
execute as @e[type=item,tag=red_inverter] at @s run title @a actionbar ["",{"text":"Blue team players were turned around!","color":"dark_purple"}]
execute as @e[type=item,tag=red_inverter] run kill @s

execute as @a[team=blue] at @s positioned ~ ~1 ~ run tag @e[type=item,nbt={Item:{id:"minecraft:prismarine_shard"}},distance=..1] add blue_inverter
execute if entity @e[type=item,tag=blue_inverter] as @a[team=red] at @s run teleport @s ~ ~ ~ ~180 ~
execute as @e[type=item,tag=blue_inverter] at @s run playsound minecraft:entity.enderman.teleport master @a[team=blue] ~ ~ ~ 100 0
execute as @e[type=item,tag=blue_inverter] at @s run playsound minecraft:entity.enderman.teleport master @a[team=red] ~ ~ ~ 100 2
execute if entity @e[type=item,tag=blue_inverter] as @a[team=red] at @s run particle portal ~ ~ ~ 0.25 0.25 0.25 5 100
execute as @e[type=item,tag=blue_inverter] at @s run title @a actionbar ["",{"text":"Red team players were turned around!","color":"dark_purple"}]
execute as @e[type=item,tag=blue_inverter] run kill @s

#fishing rod clearing
execute as @a[team=!spectator] at @s positioned ~ ~1 ~ run tag @e[type=item,nbt={Item:{id:"minecraft:fishing_rod"}},distance=..1] add delete
execute as @a[team=!spectator] at @s positioned ~ ~1 ~ run tag @e[type=item,nbt={Item:{id:"minecraft:red_dye"}},distance=..1] add delete
execute as @a[team=!spectator] at @s positioned ~ ~1 ~ run tag @e[type=item,nbt={Item:{id:"minecraft:blue_dye"}},distance=..1] add delete
execute as @e[type=item,tag=delete] run kill @s

#leaving mid-game, player count
execute unless score remove_limit game_stats matches 1 run function sette:check_activity

#second hand lobby sign cooldown
execute as @a[scores={sign=1..}] run scoreboard players remove @s sign 1

#Custom pillar generator
execute if score invalid game_stats matches 1 run title @a[x=-57,y=74,z=-10,dx=12,dy=10,dz=20] actionbar ["",{"text":"⬛","color":"red"}]
execute unless score invalid game_stats matches 1 run title @a[x=-57,y=74,z=-10,dx=12,dy=10,dz=20] actionbar ["",{"text":"⬛","color":"green"}]

#game explanation
function sette:lobby/game

#allInfo trigger (triggers are disgusting)
scoreboard players enable @a[x=-57,y=74,z=-10,dx=12,dy=10,dz=20] allInfo
scoreboard players reset @a[x=10,y=40,z=10,dx=-19,dy=30,dz=-19] allInfo

#teleport players up if they fall
execute unless entity @e[tag=ingame,type=area_effect_cloud,limit=1] as @a[scores={y=..51}] at @s run playsound minecraft:entity.enderman.teleport master @s ~ ~ ~ 100 0
execute unless entity @e[tag=ingame,type=area_effect_cloud,limit=1] as @a[scores={y=..51}] at @s run teleport @s 0 59 0 270 0

#lobby gamemode signs
execute store result score playerCount game_stats if entity @a
execute if score playerCount game_stats matches ..3 run data merge block 6 58 0 {Text1:'{"text":"Gamemode","clickEvent":{"action":"run_command","value":"playsound minecraft:block.note_block.bass master @p ~ ~ ~ 10 0.8"},"bold":true,"color":"dark_red"}',Text2:'{"text":"Clutch","clickEvent":{"action":"run_command","value":"tag @s add noCatch"},"underlined":true,"color":"black"}',Text3:'{"text":"<right-click>"}',Text4:'{"text":"[2+ players]"}'}
execute if score playerCount game_stats matches ..3 run scoreboard players set gamemode game_stats 1
execute if score playerCount game_stats matches 4.. if score gamemode game_stats matches 1 run data merge block 6 58 0 {Text1:'{"text":"Gamemode","clickEvent":{"action":"run_command","value":"scoreboard players set gamemode game_stats 0"},"bold":true,"color":"dark_red"}',Text2:'{"text":"Clutch","clickEvent":{"action":"run_command","value":"playsound minecraft:block.note_block.banjo master @a ~ ~ ~ 100 0"},"color":"black","underlined":true}',Text3:'{"text":"<right-click>","clickEvent":{"action":"run_command","value":"function sette:lobby/gamemode"}}',Text4:'{"text":"[2+ players]"}'}
execute if entity @a[tag=noCatch] run function sette:lobby/nocatch

